Index: uspace/lib/c/arch/arm32/include/libarch/fibril.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/fibril.h	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/arch/arm32/include/libarch/fibril.h	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -39,5 +39,4 @@
 #include <types/common.h>
 #include <align.h>
-#include <thread.h>
 #include <libarch/fibril_context.h>
 
Index: uspace/lib/c/generic/fibril.c
===================================================================
--- uspace/lib/c/generic/fibril.c	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/generic/fibril.c	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -36,5 +36,4 @@
 #include <adt/list.h>
 #include <fibril.h>
-#include <thread.h>
 #include <stack.h>
 #include <tls.h>
@@ -49,4 +48,5 @@
 #include <async.h>
 
+#include "private/thread.h"
 #include "private/fibril.h"
 
Index: uspace/lib/c/generic/private/thread.h
===================================================================
--- uspace/lib/c/generic/private/thread.h	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/generic/private/thread.h	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -36,8 +36,18 @@
 #define LIBC_PRIVATE_THREAD_H_
 
+#include <time.h>
 #include <abi/proc/uarg.h>
+#include <libarch/thread.h>
+#include <abi/proc/thread.h>
 
 extern void __thread_entry(void);
 extern void __thread_main(uspace_arg_t *);
+
+extern errno_t thread_create(void (*)(void *), void *, const char *, thread_id_t *);
+extern void thread_exit(int) __attribute__((noreturn));
+extern void thread_detach(thread_id_t);
+extern thread_id_t thread_get_id(void);
+extern int thread_usleep(useconds_t);
+extern unsigned int thread_sleep(unsigned int);
 
 #endif
Index: uspace/lib/c/generic/rcu.c
===================================================================
--- uspace/lib/c/generic/rcu.c	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/generic/rcu.c	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -80,5 +80,4 @@
 #include <assert.h>
 #include <time.h>
-#include <thread.h>
 
 #include "private/fibril.h"
Index: uspace/lib/c/generic/stats.c
===================================================================
--- uspace/lib/c/generic/stats.c	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/generic/stats.c	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -184,31 +184,4 @@
 }
 
-/** Get single thread statistics
- *
- * @param thread_id Thread ID we are interested in.
- *
- * @return Pointer to the stats_thread_t structure.
- *         If non-NULL then it should be eventually freed
- *         by free().
- *
- */
-stats_thread_t *stats_get_thread(thread_id_t thread_id)
-{
-	char name[SYSINFO_STATS_MAX_PATH];
-	snprintf(name, SYSINFO_STATS_MAX_PATH, "system.threads.%" PRIu64, thread_id);
-
-	size_t size = 0;
-	stats_thread_t *stats_thread =
-	    (stats_thread_t *) sysinfo_get_data(name, &size);
-
-	if (size != sizeof(stats_thread_t)) {
-		if (stats_thread != NULL)
-			free(stats_thread);
-		return NULL;
-	}
-
-	return stats_thread;
-}
-
 /** Get exception statistics.
  *
Index: uspace/lib/c/generic/thread.c
===================================================================
--- uspace/lib/c/generic/thread.c	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/generic/thread.c	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -33,5 +33,4 @@
  */
 
-#include <thread.h>
 #include <libc.h>
 #include <stdbool.h>
@@ -159,17 +158,4 @@
 }
 
-/** Join thread.
- *
- * Currently not implemented.
- *
- * @param thread TID.
- *
- * @return Thread exit status.
- */
-errno_t thread_join(thread_id_t thread)
-{
-	return 0;
-}
-
 /** Get current thread ID.
  *
Index: uspace/lib/c/include/stats.h
===================================================================
--- uspace/lib/c/include/stats.h	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ uspace/lib/c/include/stats.h	(revision 38d8849c5dae9664aadfb5dfe635e66fd4bcb908)
@@ -37,5 +37,4 @@
 
 #include <task.h>
-#include <thread.h>
 #include <stdint.h>
 #include <stdbool.h>
@@ -53,5 +52,4 @@
 
 extern stats_thread_t *stats_get_threads(size_t *);
-extern stats_thread_t *stats_get_thread(thread_id_t);
 
 extern stats_exc_t *stats_get_exceptions(size_t *);
Index: uspace/lib/c/include/thread.h
===================================================================
--- uspace/lib/c/include/thread.h	(revision c124c985b458abc83183812eb63cef12f08694dd)
+++ 	(revision )
@@ -1,55 +1,0 @@
-/*
- * Copyright (c) 2006 Jakub Jermar
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup libc
- * @{
- */
-/** @file
- */
-
-#ifndef LIBC_THREAD_H_
-#define LIBC_THREAD_H_
-
-#include <errno.h>
-#include <libarch/thread.h>
-#include <stdint.h>
-#include <abi/proc/thread.h>
-#include <time.h>
-
-extern errno_t thread_create(void (*)(void *), void *, const char *, thread_id_t *);
-extern void thread_exit(int) __attribute__((noreturn));
-extern void thread_detach(thread_id_t);
-extern errno_t thread_join(thread_id_t);
-extern thread_id_t thread_get_id(void);
-extern int thread_usleep(useconds_t);
-extern unsigned int thread_sleep(unsigned int);
-
-#endif
-
-/** @}
- */
